--[[
	15
	v1.1.4

	13
]]
CalendarExtras = {}

local core = CalendarExtras

core.modules = {}

 --[[ ------------------------ ]]--

LibStub("AceEvent-3.0"):Embed(core)
LibStub("AceHook-3.0"):Embed(core)

core.callbacks = LibStub("CallbackHandler-1.0"):New(core)

function core.NewModule(name)
	local module = {}
	core.modules[name] = module
	LibStub("AceHook-3.0"):Embed(module)
	LibStub("AceEvent-3.0"):Embed(module)
	return module
end

function core:ADDON_LOADED(event, addon)
	if addon == "CalendarExtras" then
		self:UnregisterEvent("ADDON_LOADED")
		self.ADDON_LOADED = nil

		if not CalendarExtrasDB then CalendarExtrasDB = {} end
		self.db = CalendarExtrasDB

		for _, module in pairs(self.modules) do
			if module.OnInitialize then
				module.OnInitialize()
				module.OnInitialize = nil
			end
		end
	end
end
core:RegisterEvent("ADDON_LOADED")

 --[[ ------- Callbacks ------ ]]--

-- Three callbacks, "OpenEvent" for before list update when opening event and "[Pre|Post]_Update" for before|after list update

local openingEvent

local function Opening()
	openingEvent = true
end
core:Hook("CalendarOpenEvent", Opening, true)
core:Hook("CalendarNewEvent", Opening, true) 

function core:CalendarViewEventInviteListScrollFrame_Update(...)
	if openingEvent then
		openingEvent = nil
		self.callbacks:Fire("OpenEvent", CalendarViewEventInviteListScrollFrame)
	end
	self.callbacks:Fire("Pre_Update", CalendarViewEventInviteListScrollFrame)
	self.hooks.CalendarViewEventInviteListScrollFrame_Update(...)
	self.callbacks:Fire("Pre_Post_Update", CalendarViewEventInviteListScrollFrame) -- Sorters' listupdate needs to run first so it can fix the inviteindices, but callbacks seem to in any order, lets just give it it's own callback for now... getting tired of having to fine-tune the firing-order of all these billion functions or the whole thing collapses -_-
	self.callbacks:Fire("Post_Update", CalendarViewEventInviteListScrollFrame)
end

function core:CalendarCreateEventInviteListScrollFrame_Update(...)
	if openingEvent then
		openingEvent = nil
		self.callbacks:Fire("OpenEvent", CalendarCreateEventInviteListScrollFrame)
	end
	self.callbacks:Fire("Pre_Update", CalendarCreateEventInviteListScrollFrame)
	self.hooks.CalendarCreateEventInviteListScrollFrame_Update(...)
	self.callbacks:Fire("Pre_Post_Update", CalendarCreateEventInviteListScrollFrame)
	self.callbacks:Fire("Post_Update", CalendarCreateEventInviteListScrollFrame)
end

core:RawHook("CalendarViewEventInviteListScrollFrame_Update", true)
core:RawHook("CalendarCreateEventInviteListScrollFrame_Update", true)
core:RawHook(CalendarViewEventInviteList.scrollFrame, "update", "CalendarViewEventInviteListScrollFrame_Update", true)
core:RawHook(CalendarCreateEventInviteList.scrollFrame, "update", "CalendarCreateEventInviteListScrollFrame_Update", true)